/* Copyright (C) 1997-2003 The CDG Team <cdg@nats.informatik.uni-hamburg.de>
 *  
 * This file is free software; as a special exception the author gives
 * unlimited permission to copy and/or distribute it, with or without 
 * modifications, as long as this notice is preserved.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

%{
/* ------------------------------------------------------------------------- */
#include <config.h>
#include <cdg.h>
#include <blah.h>
#include <netsearch.h>
#include <lexemgraph.h>
#include <constraintnet.h>
#include <parse.h>
#include <command.h>
#include <incrementalcompletion.h>
#include <eval.h>
#include <scache.h>
#include <write.h>
#include <levelvalue.h>
#include <set.h>

  
/* ------------------------------------------------------------------------- */
%}

%init
#ifdef SWIGTCL
%{
  cdgInitialize();
  hooker_init(interp);
%}
#else
%{
  cdgInitialize();
%}
#endif

%include "cpointer.i";
%include "cdgtypemaps.i";
%include "blah.h";

%pointer_cast(Pointer, String, pointer2string);
%pointer_cast(String, Pointer, string2pointer);

#ifdef SWIGTCL
%include "hooker.i";
#endif

%mutable;
%include "cdg.h";
%immutable;

%include "command.h";
%include "input.i";
%include "lexemgraph.h";
%include "constraintnet.h";
%include "levelvalue.h";
%include "netsearch.h";
%include "incrementalcompletion.h";
%include "statistics.h";
%include "eval.h";
%include "parse.h";
%include "scache.h";
%include "set.h";
%include "write.h";

%inline %{
/* 
 This function serves the sole purpose of finding a type`s direct successors 
 in a hierarchie`s distance-table. It is (at the moment) only used by the    
 the module allhierarchies.tcl                                               
*/
List listOfSons(Hierarchy hierarchy, int position_in_Hash_List_Of_Keys)
{
  Hashtable ht = hierarchy->types;
  List keys = hashListOfKeys(ht);
  List help, sons;
  Array a = hierarchy->distance;
  int x, y;
  Pointer item;

  item = listNth(keys, position_in_Hash_List_Of_Keys + 1);
  /* it is necessary to add 1 to position_in_Hash_List_Of_Keys, because */
  /* the function listNth starts to count with one */

  x = (int)hashGet(ht, item) - 1;
  /* 'x' is the type's x-coordinate in the distance table */

  sons = NULL;
  while (keys != NULL) {
    y = (int)hashGet(ht, listItem(keys)) - 1;
    if ((int)arrayGetElement(a, x, y) == 1) {
      sons = listPrependItem(sons, (String) listItem(keys));
    }
    help = keys;
    keys = listNext(keys);
    memFree(help);
  }
  return sons;
  listFree(keys);
}
%}

%inline %{
/*
 cast a vector access to int
*/
int intVectorElementAt(Vector v, int i)
{
  return (int)vectorElementAt(v, i);
}
%}
