# Copyright (C) 1997-2003 The CDG Team <cdg@nats.informatik.uni-hamburg.de>
#  
# This file is free software; as a special exception the author gives
# unlimited permission to copy and/or distribute it, with or without 
# modifications, as long as this notice is preserved.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

## ----------------------------------------------------------------------------
## \file itcl-hierarchy.tcl
## A small part of the itk/iwidges class hierarchy.
## This has the nice effect of a more integrated class hierarchy graph
## in doxygen.
##
## \author Michael Daum
##
## $Id: itcl-hierarchy.tcl,v 1.3 2003/04/15 14:40:45 micha Exp $
## ----------------------------------------------------------------------------

class itk::Toplevel : public itk::Archetype {};
class itk::Widget : public itk::Archetype {};
class iwidgets::Pushbutton : public itk::Widget {};
class iwidgets::Shell : public itk::Toplevel {};
class iwidgets::Dialogshell : public iwidgets::Shell {};
class iwidgets::Dialog : public iwidgets::Dialogshell {};
class iwidgets::Messagedialog : public iwidgets::Dialog {};
class iwidgets::Labeledwidget : public itk::Widget {};
class iwidgets::Scrolledwidget : public iwidgets::Labeledwidget {};
class iwidgets::Scrolledtext : public iwidgets::Scrolledwidget {};
class iwidgets::Scrolledcanvas : public iwidgets::Scrolledwidget {};
