//// Constraint Dependency Grammatik-Fragment fr das Deutsche
//// Kategorien-Hierarchien

// Johannes Heinecke, HUB, 15.12.1998
// Andreas Nolda, HUB, 1998-10-23


//// To-do-Liste
// ``CARD-N'' und ``CARD-A''


//// nderungen
// Anpassung an das neue Lexikonformat: Entfernung von ``NOMINAL'' und
// ``NOMINAL-FIN-INF-KO-U-S-ADV-PR''


//// Kategorien-Hierarchien

/// Paradigmenspezifische Kategorien-Hierarchie

wordcat ->
any (V ('V-FIN', % finites Verb
        'V-INF', % Inifinitv
        'V-PPP', % Partizip Passiv
        'V-PPA', % Partizip Aktiv
        'V-INFZU'), % _zu_-Infinitiv
     VMOD ('VMOD-FIN', % finites Modalverb
           'VMOD-INF', % Infinitiv eines Modalverbs
           'VMOD-PPP', % PPP eines Modalverbs
           'VMOD-PPA', % PPA eines Modalverbs
           'VMOD-INFZU'),
     VAUX ('VAUX-FIN',  % Auxiliar
           'VAUX-INF',
           'VAUX-PPP',
           'VAUX-PPA',
           'VAUX-INFZU'),
     VPASS ('VPASS-FIN',  % Passiv-Auxiliar
           'VPASS-INF',
           'VPASS-PPP',
           'VPASS-PPA',
           'VPASS-INFZU'),
     VMED ('VMED-FIN',  % Medial-Auxiliar
           'VMED-INF',
           'VMED-PPP',
           'VMED-PPA',
           'VMED-INFZU'),
     VCAUS ('VCAUS-FIN', % Kausativverb (``lassen'')
           'VCAUS-INF',
           'VCAUS-PPP',
           'VCAUS-PPA',
           'VCAUS-INFZU'),
     VCOP ('VCOP-FIN',  % Kopula 
           'VCOP-INF',
           'VCOP-PPP',
           'VCOP-PPA',
           'VCOP-INFZU'),
     ADJ ('V-PPP-A',    % Adjektivische Formen
          'V-PPA-A',
%           'VMOD-PPP-A',
%           'VMOD-PPA-A',
%           'VAUX-PPP-A',
%           'VAUX-PPA-A',
%           'VCAUS-PPP-A',
%           'VCAUS-PPA-A',
%           'VCOP-PPP-A',
%           'VCOP-PPA-A',
          'V-PPA-P',
          'V-PPP-P',
          'ORD-A',            % attributive Ordinalzahlen
          'ADJ-A',
          'ADJ-P',
          'P-W-P'),                     // _wie_
     'P-IMPER',  % unpers"onliches `es' wie in ``es regnet''
     'N-REFL'(
        'P-REFL', % Reflexivpronomen
         N ('N-N',    % Substantive
            'N-E',    % Eigennamen
            'P-PER',  % Personalpronomen
            'P-ROS-N',  % Substantivierte Demonstrativpronomen
            'P-POS-N',  % Substantivierte Possessivpronomen
            'P-W-N',   
            'V-PPA-N',   % Substantivierte Partizipien A/N
            'VMOD-PPA-N',
            'VCAUS-PPA-N',
            'VCOP-PPA-N',
            'VAUX-PPA-N',
            'V-PPP-N',
            'VMOD-PPP-N',
            'VCAUS-PPP-N',
            'VCOP-PPP-N',
            'VAUX-PPP-N',
            'V-INF-N', % subst. Verben
            'ADJ-N',   % Substantivierte Adjektive
            'ORD-N')   % Substantivierte Ordinalzahlen
     ),
     DET (DEF ('ART-DEF', % def. Artikel
               'P-ROS-D', % Demonstrativpronomen
               'P-POS-D', % Possessivpronomen
               'P-W-D'),
          INDEF ('ART-INDEF'), % indef Artikel
          NEGDEF ('ART-NEGDEF')), % ``kein''
     CARD,    % Karidnalzahl
     'P-EXPL',  % ``es''
     'KO-U' ('KO-U-S',  % Subordinierende Konjunktion
             'KO-U-IF'), % ``wenn, falls''
     AP ('AP-PR', % Pr"aposition
         'AP-PO', % Postpositionen
         'AP-ZL'),% Zirkumpos links  (`um')
    'AP-ZR',      % Zirkumpos rechts (`willen')
    'P-PR'('P-PR-AV', % ``darin''
           'P-W-PR-AV'), % ``worin''
     ADV,   % Adverb
     ZUSATZ, % Verbzusatz (``ein''-kaufen)
     'P-W-AV', 
     SCOP,   % Skopusw"orter
     'PTK-AM', % ``am'' besten
     'PTK-ZU'); % ``zu'' kommen


/// Formspezifische Kategorien-Hierarchie

formcat ->
any (PPA ('V-PPA',  % Partizip Aktiv
          'VMOD-PPA',
          'VCAUS-PPA',
          'VCOP-PPA',
          'VPASS-PPA',
          'VMED-PPA',
          'VAUX-PPA'),
     PPP ('V-PPP', % Partizip Passiv
          'VMOD-PPP',
          'VCAUS-PPP',
          'VCOP-PPP',
          'VPASS-PPP',
          'VMED-PPP',
          'VAUX-PPP'),
     ATTR ('PPA-A' ('V-PPA-A'   % Atttributive Formen
%                    'VMOD-PPA-A',
%                    'VCAUS-PPA-A',
%                    'VCOP-PPA-A',
%                    'VAUX-PPA-A'
                    ),
           'PPP-A' ('V-PPP-A'
%                    'VMOD-PPP-A',
%                    'VCAUS-PPP-A',
%                    'VCOP-PPP-A',
%                    'VAUX-PPP-A'
                    ),
           'ORD-A',
           'ADJ-A'),
     PRAED ('V-PPA-P',  % Pr"adikative Formen
            'V-PPP-P',
            'ADJ-P',
            'P-W-P'),                   // _wie_
     FIN ('V-FIN',
          'VMOD-FIN',
          'VCAUS-FIN',
          'VCOP-FIN',
          'VPASS-FIN',
          'VMED-FIN',
          'VAUX-FIN'),
     INF ('V-INF',
          'VMOD-INF',
          'VCAUS-INF',
          'VCOP-INF',
          'VPASS-INF',
          'VMED-INF',
          'VAUX-INF'),
     INFZU ('V-INFZU',
            'VMOD-INFZU',
            'VCAUS-INFZU',
            'VCOP-INFZU',
            'VPASS-INFZU',
            'VMED-INFZU',
            'VAUX-INFZU'),
     'P-IMPER',
     'N-REFL'('P-REFL', % Reflexivpronomina
               N ('N-N',     % Nomina 
                  'N-E',
                  'V-INF-N', % subst. Verben
                  'P-PER',
                  'P-ROS-N',
                  'P-POS-N',
                  'P-W-N',
                  'ADJ-PP-N' ('PPA-N' ('V-PPA-N',  % Substantivierte Adjektiv Formen
                                       'VMOD-PPA-N',
                                       'VCAUS-PPA-N',
                                       'VCOP-PPA-N',
                                       'VAUX-PPA-N',
                                       'V-PPP-N'),
                              'PPP-N' ('VMOD-PPP-N',
                                       'VCAUS-PPP-N',
                                       'VCOP-PPP-N',
                                       'VAUX-PPP-N'),
                              'ADJ-N',
                              'ORD-N')
                  )
              ),
     'KO-U' ('KO-U-S',  % Subordinierende Konjunktion
             'KO-U-IF'), % ``wenn, falls''
     'ADV-PR'(PR ('AP-PR',  % Adverbien und Pr"apositionen
                  'P-PR'('P-PR-AV',
                         'P-W-PR-AV')),
              ADV,
              'P-W-AV'),
     DET (WEAK ('ART-DEF',    % Determiner
                'P-ROS-D'),
          MIXED ('ART-INDEF',
                 'ART-NEGDEF',
                 'P-POS-D',
                 'P-W-D'),
          STRONG),
     CARD, 
     'P-EXPL',
     'AP-PO',
     'AP-ZL',
     'AP-ZR',
     ZUSATZ,
     SCOP,
     'PTK-AM',
     'PTK-ZU');
