#!/bin/bash 
# cdg/grammar/negra/compare.sh
#
initfile=${TMP:-/tmp}/negra-compare-init.$$


function cleanup {
  rm -f $initfile
}

trap cleanup 2 3 9 10 11 15

echo set preprocessor /bin/zcat >> $initfile
echo set prepsuffix .gz >> $initfile

if [ -f negra.cdg ]; then
  echo load negra.cdg >> $initfile
else
  if [ -f negra.cdg.gz ]; then
    echo load negra.cdg.gz >> $initfile
  else
    echo "ERROR: no negra grammar found. make one plese"
    exit 1
  fi
fi

# switch off tagger
echo tagger >> $initfile

x=1
while [ $x -lt 3001 ]; do
  sentence=s$x
  echo anno2parse auto-$sentence >> $initfile
  echo anno2parse gold-$sentence >> $initfile
  echo wordgraph $sentence >> $initfile
  echo compareparses auto-$sentence gold-$sentence >> $initfile
  echo parsedelete auto-$sentence >> $initfile
  echo parsedelete gold-$sentence >> $initfile
  let x++
done

echo quit >> $initfile


../../cdgp/cdgp -i $initfile |\
egrep -v "differs|Governor's lexical reading|, checks|Accuracy"

cleanup
