/* Copyright (C) 1997-2003 The CDG Team <cdg@nats.informatik.uni-hamburg.de>
 *  
 * This file is free software; as a special exception the author gives
 * unlimited permission to copy and/or distribute it, with or without 
 * modifications, as long as this notice is preserved.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * $Id: cdgdb.h,v 1.8 2003/12/02 15:06:55 foth Exp $
 */

#ifndef CDGDB_H
#define CDGDB_H

/* ---------------------------------------------------------------------------
 * @addtogroup Cdgdb 
 * @{
 */

/* -- INCLUDES ------------------------------------------------------------- */
#include "configure.h"
#include "db.h"
#include "stdio.h"

/* -- VARIABLES ------------------------------------------------------------ */
DB *database; 

/* -- FUNCTIONS ------------------------------------------------------------ */
extern Boolean dbOpen(String filename);
extern Boolean dbClose(void);
extern List dbGetEntries(String key);
extern Boolean dbLoad(String key); 
extern Boolean dbLoadAll(List keys); 
extern void dbInitialize(void);
extern void dbFinalize(void);
extern Boolean dbOpenCdgFile(String filename); 
extern Boolean dbAvailable(void);
/* ------------------------------------------------------------------------- */
/** @} */
#endif /* don't insert anything after this #endif */
