/* Copyright (C) 1997-2003 The CDG Team <cdg@nats.informatik.uni-hamburg.de>
 *  
 * This file is free software; as a special exception the author gives
 * unlimited permission to copy and/or distribute it, with or without 
 * modifications, as long as this notice is preserved.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * Author: Ingo Schroeder (see also AUTHORS and THANKS for more)
 * $Id: command.h,v 1.53 2003/10/09 08:09:49 foth Exp $
 */

/* ---------------------------------------------------------------------------
 * @addtogroup Command 
 * @{ */

#ifndef COMMAND_H
#define COMMAND_H

/* -- INCLUDES ---------------------------------------------------------- */
#include <stdio.h>
#include <readline/readline.h>
#include <readline/history.h>

/* -- MACROS ------------------------------------------------------------ */

/** message to be displayed at startup */
#define STARTUPMSG "CDG parser, Copyright (C) 1997-2003 The CDG Team\n"\
"The CDG parser comes with ABSOLUTELY NO WARRANTY.\n"\
"This is free software, and you are welcome to redistribute it\n"\
"under certain conditions; type `license' for details.\n"\
"\n"\
"For more information see\n"\
"\n"\
"  http://nats-www.informatik.uni-hamburg.de/~dawai/\n"\
"\n"\
"The CDG Team can be contacted at\n"\
"\n"\
"  cdg@nats.informatik.uni-hamburg.de\n"\
"\n"\
"Type `help' for a short help.\n"\
"\n"\
"\n"\
""

/* ---------------------------------------------------------------------- */

#ifndef SWIG
/* 
 * CAUTION: these functions are not exported to the language bindings,
 *	use commandEval !!!
 */
extern Boolean cmdActivate(int no, char **args);
extern Boolean cmdAnno2Parse(int no, char **args);
extern Boolean cmdAnnotation(int no, char **args);
extern Boolean cmdChunk(int no, char **args);
extern Boolean cmdCompareParses(int no, char **args);
extern Boolean cmdCompile(int no, char **args);
extern Boolean cmdConstraint(int no, char **args);
extern Boolean cmdDeactivate(int no, char **args);
extern Boolean cmdDistance(int no, char **args);
extern Boolean cmdEdges(int no, char **args);
extern Boolean cmdFrobbing(int no, char **args);
extern Boolean cmdGls(int no, char **args);
extern Boolean cmdHelp(int no, char **args);
extern Boolean cmdHierarchy(int no, char **args);
extern Boolean cmdHook( int no, char **args );
extern Boolean cmdISearch(int no, char **args);
extern Boolean cmdIncrementalCompletion(int no, char **args);
extern Boolean cmdInputwordgraph(int no, char **args);
extern Boolean cmdLevel(int no, char **args);
extern Boolean cmdLevelsort( int no, char **args );
extern Boolean cmdLexicon(int no, char **args);
extern Boolean cmdLicense(int no, char **args);
extern Boolean cmdLoad(int no, char **args);
extern Boolean cmdLs(int no, char **args);
extern Boolean cmdNet(int no, char **args);
extern Boolean cmdNetdelete(int no, char **args);
extern Boolean cmdNetsearch(int no, char **args);
extern Boolean cmdNewnet(int no, char **args);
extern Boolean cmdNonSpecCompatible(int no, char **args);
extern Boolean cmdParsedelete(int no, char **args);
extern Boolean cmdPrintParse(int no, char **args);
extern Boolean cmdPrintParses(int no, char **args);
extern Boolean cmdQuit(int no, char **args);
extern Boolean cmdRenewnet(int no, char **args);
extern Boolean cmdReset(int no, char **args);
extern Boolean cmdSection(int no, char **args);
extern Boolean cmdSet(int no, char **args);
extern Boolean cmdShift(int no, char **args);
extern Boolean cmdShowlevel(int no, char **args);
extern Boolean cmdStatus(int no, char **args);
extern Boolean cmdTagger(int no, char **args);
extern Boolean cmdTesting(int no, char **args);
extern Boolean cmdUseconstraint(int no, char **args);
extern Boolean cmdUselevel(int no, char **args);
extern Boolean cmdVerify(int no, char **args);
extern Boolean cmdVersion(int no, char **args);
extern Boolean cmdWeight(int no, char **args);
extern Boolean cmdWordgraph(int no, char **args);
extern Boolean cmdWriteNet(int no, char **args);
extern Boolean cmdWriteAnno(int no, char **args);
extern Boolean cmdWriteParses(int no, char **args);
extern Boolean cmdWriteWordgraph(int no, char **args);
extern Boolean cmdUseLexicon(int no, char **args);
extern Boolean cmdCloseDB();
extern Boolean cmdParses2prolog(int no, char **args);
extern Boolean cmdAnnos2prolog(int no, char **args);
#endif

extern Boolean commandEval(String line);
extern Boolean commandLoop(String prompt);

/* ---------------------------------------------------------------------- */

#endif /* don't insert anything after this #endif */
