/*
 * File: predicates.h
 * Author: Ingo Schroeder
 * Purpose: header file for predicates.c
 * Birth: 17/3/97
 *
 * $Id: predicates.h,v 1.18 2004/01/02 11:17:26 foth Exp $
 */

#ifndef PREDICATES_H
#define PREDICATES_H

/* -- INCLUDES ---------------------------------------------------------- */
#include "cdg.h"
#include <blah.h>
#include "constraintnet.h"
#include "eval.h"

/* -- MACROS ------------------------------------------------------------ */
/* -- TYPE DEFINITIONS -------------------------------------------------- */
typedef struct {
  String functor;
  BooleanFunction *function;
  String functionName;
  Boolean is_context_sensitive;
  String arity;
  String doc;
} CDGPredicateStruct;
typedef CDGPredicateStruct* CDGPredicate;

/* -- FUNCTIONS --------------------------------------------------------- */
extern CDGPredicate predGetFunction(String functor);
extern String predGetFunctionName(String functor);
extern Boolean predStart(List args, LexemGraph lg, Vector context);
extern Boolean predStop(List args, LexemGraph lg, Vector context);
extern Boolean predRoot(List args, LexemGraph lg, Vector context);
extern Boolean predSpec(List args, LexemGraph lg, Vector context);
extern Boolean predNonSpec(List args, LexemGraph lg, Vector context);
extern Boolean predChunkHead(List args, LexemGraph lg, Vector context);
extern Boolean predPrint(List args, LexemGraph lg, Vector context);
extern Boolean predSubsumes(List args, LexemGraph lg, Vector context);
extern Boolean predExists(List args, LexemGraph lg, Vector context);
extern Boolean predCompatible(List args, LexemGraph lg, Vector context);
extern Boolean predHas(List args, LexemGraph lg, Vector context);
extern Boolean predIs(List args, LexemGraph lg, Vector context);
extern Boolean predOccur(List args, LexemGraph lg, Vector context);
extern Boolean predCycle(List args, LexemGraph lg, Vector context);
extern Boolean predBetween(List args, LexemGraph lg, Vector context);
extern Boolean predUnder(List args, LexemGraph lg, Vector context);
extern Boolean predConnected(List args, LexemGraph lg, Vector context);

/* ---------------------------------------------------------------------- */
#endif /* don't insert anything after this #endif */

