/* Copyright (C) 1997-2003 The CDG Team <cdg@nats.informatik.uni-hamburg.de>
 *  
 * This file is free software; as a special exception the author gives
 * unlimited permission to copy and/or distribute it, with or without 
 * modifications, as long as this notice is preserved.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * $Id: timer.h,v 1.16 2003/09/30 15:26:32 maurer Exp $
 */

/* ---------------------------------------------------------------------------
 * @addtogroup Timer 
 * @{
 */

#ifndef _TIMER_H
#define _TIMER_H
#include <configure.h>
#include <my_unistd.h>
#include <my_time.h>

#include <sys/resource.h>


#define MyMAXLONG ((long)~(1L << ((8 * (int)sizeof(long)) - 1)))

/* -- TYPE DEFINITIONS -------------------------------------------------- */
typedef clock_t TimerFast;    /**< the fast timer */ 
typedef struct timeval TimerStruct, *Timer; /**< the slow timer */ 

/* -- FUNCTIONS --------------------------------------------------------- */
extern void timerInitialize(void);

extern TimerFast timerStartFast();
extern unsigned long timerElapsedFast(TimerFast);

extern void timerStart(Timer);
extern Timer timerNew();
extern void timerFree(Timer);
extern unsigned long timerElapsed(Timer);

extern void timerSetAlarm(long unsigned int limit);
extern void timerStopAlarm(void);

/* -- VARIABLES --------------------------------------------------------- */
extern Boolean timerExpired;


#endif
/** @} */
