#!@perl@

use warnings;
use strict;
use lib "@top_builddir@/bindings";
use lib "@top_builddir@/bindings/.libs";
use CDG;

my $debug = 0;

sub testCmdEval
{
  my $command = shift;
  commandEval $command or die $command;
}

testCmdEval "set verbosity 0" if ! $debug;
testCmdEval "set debug on" if $debug;
testCmdEval "set preprocessor /bin/zcat";
testCmdEval "set prepsuffix .gz";
testCmdEval "load @testgrammar@";

print "DEBUG: inputCurrentGrammar=$CDG::inputCurrentGrammar\n" if $debug;

print "DEBUG: getting lexiconItems\n" if $debug;
my $lexiconItems = InputStruct_lexicon_get($CDG::inputCurrentGrammar);
die "no lexicon found" if ! defined $lexiconItems;

print "DEBUG: hashIteratorNew\n" if $debug; 
my $hi = hashIteratorNew($lexiconItems); 

print "DEBUG: hashSize\n" if $debug; 
my $size = hashSize($lexiconItems);
die "no lexicon found\n" if !$size;

#print "hash size = $size\n";
my $noEntries = 0;
my $noForms = 0;
while (my $forms = hashIteratorNextValue($hi)) {
  print "DEBUG: LexiconItemStruct_word_get\n" if $debug; 
  my $word = LexiconItemStruct_word_get(listItem($forms));
  print "$word = " if $debug;

  for (my $l = $forms ;$l; $l = listNext($l)) {
    my $entry = listItem($l);
    my $id = LexiconItemStruct_description_get $entry;
    print "$id " if $debug;
    $noForms += 1;
  }
  print "\n" if $debug;
  $noEntries += 1;
}
cdgFinalize;
print "INFO: counted $noEntries lexicon entries with overall $noForms word forms\n" if $debug;

die "hash size is $size, but only counted $noEntries lexical entries\n"
  if $size != $noEntries;

