/* Copyright (C) 1997-2002 The BLAH Team <blah@nats.informatik.uni-hamburg.de>
 *
 * This file is free software; as a special exception the author gives
 * unlimited permission to copy and/or distribute it, with or without
 * modifications, as long as this notice is preserved.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */
 
/*
 * The functions tested in ListAgenda Module
 *
 * laNew
 * laSize
 * laMaxSize
 * laMaxSizeSoFar
 * laIsEmpty
 * laIsTruncated
 * laInsert
 * laDelete
 * laIteratorNew
 * laIteratorNextItem
 * laIteratorDelete
 *
 * Not tested
 *
 * laGetBest
 * laRemoveBest
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#include <string.h>
#include <blah.h>
#include <assert.h>
#include <stdlib.h>

int main(int argc, char **argv)
{
  char *a[] =
    { "Mike", "Killian", "Ajay", "Sofiya", "Aarthi", "Krish", "Adarsh",
    "Sebastian", "Louis", "Kathrine", "Peter"
  };
  ListAgenda la;
  int maxs, i;
  Boolean ins, trnc;
  String outstring, valstr;
  ListAgendaIterator li;

  void func(Pointer p) {
    free(p);
  }

  /* Creating a new listagenda */
  la = laNew(10, func);

  /* Testing for the laSize,laMaxSize */
  assert(laSize(la) == 0);
  maxs = laMaxSize(la);
  assert(maxs == 10);

  /* Test laInsert, laIsEmpty Inserting 9 elements ( 0 to 8 ) */

  for (i = 0; i < maxs - 1; i++) {
    ins = laInsert(la, (20.0 - i), a[i]);	/* a[0] has max score;a[8]
						 * has min score */
    assert(ins == TRUE);
  }
  assert(laIsEmpty(la) == FALSE);

  /* Test for laMaxSizeSoFar */

  assert(laMaxSizeSoFar(la) == 9);
  assert(laMaxSizeSoFar(la) == laMaxSize(la) - 1);

  /* Testing laIsTruncated */

  trnc = laIsTruncated(la);
  assert(trnc == FALSE);

  for (i = 9; i < 11; i++)
    ins = laInsert(la, (1.0 + i), a[i]);	/* a[10] Inserted -score 11 */
  assert(ins == FALSE);		       /* a[11] Trunc'ed -score 10 */
  trnc = laIsTruncated(la);
  assert(trnc == TRUE);

  /* Test for laGetBest,laRemoveBest */

  outstring = (String) laGetBest(la);
  printf("%s", outstring);

  /* Testing for laIteratorNextItem */

  li = laIteratorNew(la);

  valstr = laIteratorNextItem(li);
  assert(valstr == a[0]);

  for (i = 0; i < 9; i++) {
    valstr = laIteratorNextItem(li);
    assert(valstr == a[i]);
  }

  /* a[9] is truncated */
  valstr = laIteratorNextItem(li);
  assert(valstr == a[10]);

  /* laIteratorDelete */
  laIteratorDelete(li);

  blahFinalize();

  return 0;
}
