/* Copyright (C) 1997-2003 The BLAH Team <blah@nats.informatik.uni-hamburg.de>
 *  
 * This file is free software; as a special exception the author gives
 * unlimited permission to copy and/or distribute it, with or without 
 * modifications, as long as this notice is preserved.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#ifdef HAVE_CONFIG_H
  #include <config.h>
#endif

#include <assert.h>
#include <blah.h>
#include <math.h>

//#define VERBOSE

int main(int argc, char **argv)
{
  String str;
  int i;

  blahInitialize();

  str = strCat(strCat(NULL,"Hallo "), "Welt");
#ifdef VERBOSE
  printf("str=%s, pointer=%p\n", str, str);
#endif
  assert(strcmp(str, "Hallo Welt") == 0);

  str = strCat("Hallo", NULL);
#ifdef VERBOSE
  printf("str=%s, pointer=%p\n", str, str);
#endif
  assert(strcmp(str, "Hallo") == 0);

  str = strCat(NULL, "Welt");
#ifdef VERBOSE
  printf("str=%s, pointer=%p\n", str, str);
#endif
  assert(strcmp(str, "Welt") == 0);

  str = strPrintf("Hello World ");
  assert(strcmp(str, "Hello World ") == 0);
  for (i = 0; i < 20; i++) {
    str = strCat(str, str);
#ifdef VERBOSE
    //printf("%s\n", str);
    printf("i=%d, len=%d, 24*2^n=%d\n", i, 
	strlen(str), (int)(24*pow(2,i)));
#endif
    assert(strlen(str) == 24*pow(2,i));
  }
  

  blahFinalize();
  return 0;
}
