/* Copyright (C) 1997-2003 The BLAH Team <blah@nats.informatik.uni-hamburg.de>
 *  
 * This file is free software; as a special exception the author gives
 * unlimited permission to copy and/or distribute it, with or without 
 * modifications, as long as this notice is preserved.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#ifdef HAVE_CONFIG_H
  #include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <blah.h>

//#define VERBOSE

int main(int argc, char **argv)
{
  String str1 = NULL;
  String str2 = NULL;
  int i, n;
  
  blahInitialize();

  str1 = strRegister("Hello World");
  str2 = strRegister("Hello World");
  
#ifdef VERBOSE
  printf("str1=%s, pointer=%p\n", str1, str1);
  printf("str2=%s, pointer=%p\n", str2, str2);
#endif

  assert(strcmp(str1, "Hello World") == 0);
  assert(strcmp(str2, "Hello World") == 0);
  assert(str1 == str2);

//  strFree(str1);
#ifdef VERBOSE
  printf("str1=%s, pointer=%p\n", str1, str1);
  printf("str2=%s, pointer=%p\n", str2, str2);
#endif
  assert(strcmp(str1, "Hello World") == 0);
  assert(strcmp(str2, "Hello World") == 0);
  assert(str1 == str2);

  str1 = strRegister(str2);
#ifdef VERBOSE
  printf("str1=%s, pointer=%p\n", str1, str1);
  printf("str2=%s, pointer=%p\n", str2, str2);
#endif
  assert(strcmp(str1, "Hello World") == 0);
  assert(strcmp(str2, "Hello World") == 0);
  assert(str1 == str2);

  str1 = strCopy(str2);
#ifdef VERBOSE
  printf("str1=%s, pointer=%p\n", str1, str1);
  printf("str2=%s, pointer=%p\n", str2, str2);
#endif
  assert(strcmp(str1, "Hello World") == 0);
  assert(strcmp(str2, "Hello World") == 0);
  assert(str1 != str2);
  memFree(str1);
  strFree(str2);

  for (i = 0; i < 20; i++) {
    str1 = strPrintf("%d", i % 10);
    assert(str1 != NULL);
#ifdef VERBOSE
    printf("str1='%s', pointer=%p\n", str1, str1);
#endif
    sscanf(str1, "%d", &n);
    assert(n == (i % 10));
    strFree(str1);
  }

  blahFinalize();
  return 0;
}
