/* Copyright (C) 1997-2003 The BLAH Team <blah@nats.informatik.uni-hamburg.de>
 *  
 * This file is free software; as a special exception the author gives
 * unlimited permission to copy and/or distribute it, with or without 
 * modifications, as long as this notice is preserved.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#ifdef HAVE_CONFIG_H
  #include <config.h>
#endif

#include <assert.h>
#include <blah.h>

//#define VERBOSE

int main(int argc, char **argv)
{
  String str, str2;

  blahInitialize();

  str = strPrintf("%s %s", "Hello", "World");
#ifdef VERBOSE
  printf("str=%s pointer=%p\n", str, str);
#endif
  assert(strcmp(str, "Hello World") == 0);

  str = strPrintf("%d", 4711);
#ifdef VERBOSE
  printf("str=%s\n", str);
#endif
  assert(strcmp(str, "4711") == 0);

  str = strPrintf("%4.3e", 4.711);
#ifdef VERBOSE
  printf("str=%s\n", str);
#endif
  assert(strcmp(str, "4.711e+00") == 0);

  str = strPrintf("%f", 4.711);
#ifdef VERBOSE
  printf("str=%s\n", str);
#endif
  assert(strcmp(str, "4.711000") == 0);

  str = strPrintf("%g", 4.711);
#ifdef VERBOSE
  printf("str=%s\n", str);
#endif
  assert(strcmp(str, "4.711") == 0);

  str = strPrintf("%s", "Hello");
#ifdef VERBOSE
  printf("str=%s\n", str);
#endif
  assert(strcmp(str, "Hello") == 0);
  str2 = strPrintf("%s %s", str, "World");
#ifdef VERBOSE
  printf("str=%s, pointer=%p\n", str, str);
  printf("str2=%s, pointer=%p\n", str2, str2);
#endif
#if 0
  assert(strcmp(str, "Hello World") == 0);
#endif

  blahFinalize();
  return 0;
}
