#!/bin/sh

prefix=@prefix@
CDGP=$prefix/bin/cdgp

COMPILEARGS=""
VERBOSITYLEVEL=1
DEVNULL=""

while getopts o:chvq c
do
  case $c in 
    o)		COMPILEARGS="$COMPILEARGS -$c $OPTARG" ;;
    h | c)	COMPILEARGS="$COMPILEARGS -$c" ;;
    v)		VERBOSITYLEVEL=$[$VERBOSITYLEVEL + 1];;
    q)		DEVNULL=">/dev/null 2>&1"
  esac
done
shift `expr $OPTIND - 1`

GRAMMARFILES=$*
  
ERROR="on"
INFO="off"
WARNING="off"
PROFILE="off"
DEBUG="off"

[[ $VERBOSITYLEVEL > 0 ]] && ERROR="on"
[[ $VERBOSITYLEVEL > 1 ]] && INFO="on"
[[ $VERBOSITYLEVEL > 2 ]] && WARNING="on"
[[ $VERBOSITYLEVEL > 3 ]] && PROFILE="on"
[[ $VERBOSITYLEVEL > 4 ]] && DEBUG="on"

echo "
  set edges off
  set searchresult off
  set cache off
  set info $INFO
  set error $ERROR
  set warning $WARNING
  set profile $PROFILE
  set debug $DEBUG
  load $GRAMMARFILES
  compile $COMPILEARGS
" | eval $CDGP -i none $DEVNULL
