# Copyright (C) 1997-2003 The CDG Team <cdg@nats.informatik.uni-hamburg.de>
#  
# This file is free software; as a special exception the author gives
# unlimited permission to copy and/or distribute it, with or without 
# modifications, as long as this notice is preserved.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

## ----------------------------------------------------------------------------
## FlatButton - a flatened pushbutton.
## This is just a button with a more KDEish look and feel mainly used in
## the toolbars.
##
## \author Michael Daum
##
## $Id: FlatButton.tcl,v 1.7 2003/02/27 13:02:26 micha Exp $
## ----------------------------------------------------------------------------
class FlatButton {
  inherit iwidgets::Pushbutton

  constructor {args} {}; ## \type TclList
};

## ----------------------------------------------------------------------------
## constructor
## ----------------------------------------------------------------------------
body FlatButton::constructor {args} {

  bind $itk_component(pushbutton) <Enter> {%W configure -relief raised}
  bind $itk_component(pushbutton) <Leave> {%W configure -relief flat}
  
  eval itk_initialize $args

  configure \
    -defaultringpad 0 \
    -borderwidth 2 \
    -padx 2 \
    -pady 2 \
    -relief flat
  
  $itk_component(pushbutton) configure \
    -relief flat \
}
