# Copyright (C) 1997-2003 The CDG Team <cdg@nats.informatik.uni-hamburg.de>
#  
# This file is free software; as a special exception the author gives
# unlimited permission to copy and/or distribute it, with or without 
# modifications, as long as this notice is preserved.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

## ----------------------------------------------------------------------------
## YadaPlainDocument - abstract yada document.
## \ingroup YadaDocuments
##
## \author Michael Daum 
##
## $Id: YadaPlainDocument.tcl,v 1.6 2003/02/27 13:02:27 micha Exp $
## ----------------------------------------------------------------------------
class YadaPlainDocument {

  # variables ----------------------------------------------------------------
  
  ## name of the document
  public variable name ""
  
  ## flag indicating initialization.
  ## Possible falues are 0 and 1. init() sets this to 1 when it is called
  ## in the init chain calls of inheriting classes, 
  ## i.e. YadaConfigDocument::init() or YadaRunnableDocument::init().
  protected variable _isInitialized 0

  # methods ------------------------------------------------------------------
  public method activationHandle {}; ## \virtual
  public method deActivationHandle {}; ## \virtual
  public method init {} ;## \virtual
  public method setToggle {name {value ""}}; ## \type TclString, TclRef, \virtual

  constructor {} {}
};

## ----------------------------------------------------------------------------
## constructor
## ----------------------------------------------------------------------------
body YadaPlainDocument::constructor {} {
}

## ----------------------------------------------------------------------------
## activationHandle
## ----------------------------------------------------------------------------
body YadaPlainDocument::activationHandle {} {
}

## ----------------------------------------------------------------------------
## deActivationHandle
## ----------------------------------------------------------------------------
body YadaPlainDocument::deActivationHandle {} {
}

## ----------------------------------------------------------------------------
## init
## ----------------------------------------------------------------------------
body YadaPlainDocument::init {} {
  if {!$_isInitialized} {
    set _isInitialized 1
  }
}

## ----------------------------------------------------------------------------
## setToggle
## ----------------------------------------------------------------------------
body YadaPlainDocument::setToggle {name {value ""}} {
}
