# Copyright (C) 1997-2003 The CDG Team <cdg@nats.informatik.uni-hamburg.de>
#  
# This file is free software; as a special exception the author gives
# unlimited permission to copy and/or distribute it, with or without 
# modifications, as long as this notice is preserved.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

## ----------------------------------------------------------------------------
## YadaStartUp - the YADA splash screen.
## \ingroup YadaDocuments
##
## \author Michael Daum
##
## $Id: YadaStartUp.tcl,v 1.9 2003/02/27 13:02:27 micha Exp $
## ----------------------------------------------------------------------------
class YadaStartUp {
  inherit YadaDocument

  constructor {args} {}; ## \type TclList
};

## ----------------------------------------------------------------------------
## constructor
## ----------------------------------------------------------------------------
body YadaStartUp::constructor {args} {
  global env
  
  set logo [YadaImages::get logo]
  set height [image height $logo]
  set width [image width $logo]

  itk_component add f1 {
    frame $itk_component(childsite).f1
  }

  itk_component add canvas {
    canvas $itk_component(childsite).canvas \
      -height $height -width $width \
  }

  itk_component add f2 {
    frame $itk_component(childsite).f2
  }

  $itk_component(canvas) create image 0 0 -image $logo -anchor nw -tag logo
  pack $itk_component(f1) \
       $itk_component(canvas) \
       $itk_component(f2) -side top -anchor center -fill y  -expand 1

  eval itk_initialize $args
  .main registerDocument $this
}
