#!/bin/sh
#\
exec wish "$0" "$@" 

# Copyright (C) 1997-2003 The CDG Team <cdg@nats.informatik.uni-hamburg.de>
#  
# This file is free software; as a special exception the author gives
# unlimited permission to copy and/or distribute it, with or without 
# modifications, as long as this notice is preserved.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

#----------------------------------------------------------------------------
# set the environment
#----------------------------------------------------------------------------

# the yada prefix in YADA_PATH
if {![info exists env(YADA_PATH)]} {
  set env(YADA_PATH) "~/Projekt/yada"
}
set env(YADA_PATH) [glob -nocomplain $env(YADA_PATH)]
if {![file exists $env(YADA_PATH)]} {
   puts "ERROR: can't locate the yada directory, please set YADA_PATH"
   exit
}

# the yada lib in YADA_LIB
if {![info exists env(YADA_LIB)]} {
  set env(YADA_LIB) "$env(YADA_PATH)/lib"
}
set env(YADA_LIB) [glob -nocomplain $env(YADA_LIB)]
if {![file exists $env(YADA_LIB)]} {
   puts "ERROR: can't locate the yada library, please set YADA_LIB"
   exit
}
lappend auto_path $env(YADA_LIB)

# the yada images in YADA_IMAGES
if {![info exists env(YADA_IMAGES)]} {
  set env(YADA_IMAGES) "$env(YADA_PATH)/images"
}
set env(YADA_IMAGES) [glob -nocomplain $env(YADA_IMAGES)]
if {![file exists $env(YADA_IMAGES)]} {
   puts "ERROR: can't locate the yada images, please set YADA_IMAGES"
   exit
}

#----------------------------------------------------------------------------
# load additional packages
#----------------------------------------------------------------------------
package require Iwidgets

# ----------------------------------------------------------------------------
# ----------------------------------------------------------------------------

wm withdraw .
source $env(YADA_LIB)/YadaOptions.tcl
set fs [FileSelector .fs \
  -title "Select a file" \
  -width 500 \
  -height 400 \
  -filter {"*.tcl" "*.c" "*.h" "*.c *.h"} \
  -mode "multifile" \
  -master ""]

source $env(YADA_LIB)/bugfixes.tcl

 

# ----------------------------------------------------------------------------
# ----------------------------------------------------------------------------

# ----------------------------------------------------------------------------
while {[set selection [$fs activate -directory ~]] != ""} {
  puts "selection=`$selection'"
  puts "--------------------------------------------------------------------"
}
exit
